diff --git a/src/backend/utils/cache/lsyscache.c b/src/backend/utils/cache/lsyscache.c
index 1b7e11b93e..e189e5e564 100644
--- a/src/backend/utils/cache/lsyscache.c
+++ b/src/backend/utils/cache/lsyscache.c
@@ -90,7 +90,7 @@ get_op_opfamily_strategy(Oid opno, Oid opfamily)
 						 ObjectIdGetDatum(opfamily));
 	if (!HeapTupleIsValid(tp))
 		return 0;
-	amop_tup = (Form_pg_amop) GETSTRUCT(tp);
+	amop_tup = GETSTRUCT(pg_amop, tp);
 	result = amop_tup->amopstrategy;
 	ReleaseSysCache(tp);
 	return result;
@@ -115,7 +115,7 @@ get_op_opfamily_sortfamily(Oid opno, Oid opfamily)
 						 ObjectIdGetDatum(opfamily));
 	if (!HeapTupleIsValid(tp))
 		return InvalidOid;
-	amop_tup = (Form_pg_amop) GETSTRUCT(tp);
+	amop_tup = GETSTRUCT(pg_amop, tp);
 	result = amop_tup->amopsortfamily;
 	ReleaseSysCache(tp);
 	return result;
@@ -146,7 +146,7 @@ get_op_opfamily_properties(Oid opno, Oid opfamily, bool ordering_op,
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "operator %u is not a member of opfamily %u",
 			 opno, opfamily);
-	amop_tup = (Form_pg_amop) GETSTRUCT(tp);
+	amop_tup = GETSTRUCT(pg_amop, tp);
 	*strategy = amop_tup->amopstrategy;
 	*lefttype = amop_tup->amoplefttype;
 	*righttype = amop_tup->amoprighttype;
@@ -175,7 +175,7 @@ get_opfamily_member(Oid opfamily, Oid lefttype, Oid righttype,
 						 Int16GetDatum(strategy));
 	if (!HeapTupleIsValid(tp))
 		return InvalidOid;
-	amop_tup = (Form_pg_amop) GETSTRUCT(tp);
+	amop_tup = GETSTRUCT(pg_amop, tp);
 	result = amop_tup->amopopr;
 	ReleaseSysCache(tp);
 	return result;
@@ -223,7 +223,7 @@ get_ordering_op_properties(Oid opno,
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	tuple = &catlist->members[i]->tuple;
-		Form_pg_amop aform = (Form_pg_amop) GETSTRUCT(tuple);
+		Form_pg_amop aform = GETSTRUCT(pg_amop, tuple);
 
 		/* must be btree */
 		if (aform->amopmethod != BTREE_AM_OID)
@@ -315,7 +315,7 @@ get_ordering_op_for_equality_op(Oid opno, bool use_lhs_type)
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	tuple = &catlist->members[i]->tuple;
-		Form_pg_amop aform = (Form_pg_amop) GETSTRUCT(tuple);
+		Form_pg_amop aform = GETSTRUCT(pg_amop, tuple);
 
 		/* must be btree */
 		if (aform->amopmethod != BTREE_AM_OID)
@@ -376,7 +376,7 @@ get_mergejoin_opfamilies(Oid opno)
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	tuple = &catlist->members[i]->tuple;
-		Form_pg_amop aform = (Form_pg_amop) GETSTRUCT(tuple);
+		Form_pg_amop aform = GETSTRUCT(pg_amop, tuple);
 
 		/* must be btree equality */
 		if (aform->amopmethod == BTREE_AM_OID &&
@@ -428,7 +428,7 @@ get_compatible_hash_operators(Oid opno,
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	tuple = &catlist->members[i]->tuple;
-		Form_pg_amop aform = (Form_pg_amop) GETSTRUCT(tuple);
+		Form_pg_amop aform = GETSTRUCT(pg_amop, tuple);
 
 		if (aform->amopmethod == HASH_AM_OID &&
 			aform->amopstrategy == HTEqualStrategyNumber)
@@ -528,7 +528,7 @@ get_op_hash_functions(Oid opno,
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	tuple = &catlist->members[i]->tuple;
-		Form_pg_amop aform = (Form_pg_amop) GETSTRUCT(tuple);
+		Form_pg_amop aform = GETSTRUCT(pg_amop, tuple);
 
 		if (aform->amopmethod == HASH_AM_OID &&
 			aform->amopstrategy == HTEqualStrategyNumber)
@@ -611,7 +611,7 @@ get_op_btree_interpretation(Oid opno)
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	op_tuple = &catlist->members[i]->tuple;
-		Form_pg_amop op_form = (Form_pg_amop) GETSTRUCT(op_tuple);
+		Form_pg_amop op_form = GETSTRUCT(pg_amop, op_tuple);
 		StrategyNumber op_strategy;
 
 		/* must be btree */
@@ -649,7 +649,7 @@ get_op_btree_interpretation(Oid opno)
 			for (i = 0; i < catlist->n_members; i++)
 			{
 				HeapTuple	op_tuple = &catlist->members[i]->tuple;
-				Form_pg_amop op_form = (Form_pg_amop) GETSTRUCT(op_tuple);
+				Form_pg_amop op_form = GETSTRUCT(pg_amop, op_tuple);
 				StrategyNumber op_strategy;
 
 				/* must be btree */
@@ -712,7 +712,7 @@ equality_ops_are_compatible(Oid opno1, Oid opno2)
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	op_tuple = &catlist->members[i]->tuple;
-		Form_pg_amop op_form = (Form_pg_amop) GETSTRUCT(op_tuple);
+		Form_pg_amop op_form = GETSTRUCT(pg_amop, op_tuple);
 
 		/* must be btree or hash */
 		if (op_form->amopmethod == BTREE_AM_OID ||
@@ -763,7 +763,7 @@ comparison_ops_are_compatible(Oid opno1, Oid opno2)
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	op_tuple = &catlist->members[i]->tuple;
-		Form_pg_amop op_form = (Form_pg_amop) GETSTRUCT(op_tuple);
+		Form_pg_amop op_form = GETSTRUCT(pg_amop, op_tuple);
 
 		if (op_form->amopmethod == BTREE_AM_OID)
 		{
@@ -804,7 +804,7 @@ get_opfamily_proc(Oid opfamily, Oid lefttype, Oid righttype, int16 procnum)
 						 Int16GetDatum(procnum));
 	if (!HeapTupleIsValid(tp))
 		return InvalidOid;
-	amproc_tup = (Form_pg_amproc) GETSTRUCT(tp);
+	amproc_tup = GETSTRUCT(pg_amproc, tp);
 	result = amproc_tup->amproc;
 	ReleaseSysCache(tp);
 	return result;
@@ -830,7 +830,7 @@ get_attname(Oid relid, AttrNumber attnum, bool missing_ok)
 						 ObjectIdGetDatum(relid), Int16GetDatum(attnum));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_attribute att_tup = (Form_pg_attribute) GETSTRUCT(tp);
+		Form_pg_attribute att_tup = GETSTRUCT(pg_attribute, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(att_tup->attname));
@@ -860,7 +860,7 @@ get_attnum(Oid relid, const char *attname)
 	tp = SearchSysCacheAttName(relid, attname);
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_attribute att_tup = (Form_pg_attribute) GETSTRUCT(tp);
+		Form_pg_attribute att_tup = GETSTRUCT(pg_attribute, tp);
 		AttrNumber	result;
 
 		result = att_tup->attnum;
@@ -892,7 +892,7 @@ get_attstattarget(Oid relid, AttrNumber attnum)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 attnum, relid);
-	att_tup = (Form_pg_attribute) GETSTRUCT(tp);
+	att_tup = GETSTRUCT(pg_attribute, tp);
 	result = att_tup->attstattarget;
 	ReleaseSysCache(tp);
 	return result;
@@ -922,7 +922,7 @@ get_attgenerated(Oid relid, AttrNumber attnum)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 attnum, relid);
-	att_tup = (Form_pg_attribute) GETSTRUCT(tp);
+	att_tup = GETSTRUCT(pg_attribute, tp);
 	result = att_tup->attgenerated;
 	ReleaseSysCache(tp);
 	return result;
@@ -944,7 +944,7 @@ get_atttype(Oid relid, AttrNumber attnum)
 						 Int16GetDatum(attnum));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_attribute att_tup = (Form_pg_attribute) GETSTRUCT(tp);
+		Form_pg_attribute att_tup = GETSTRUCT(pg_attribute, tp);
 		Oid			result;
 
 		result = att_tup->atttypid;
@@ -977,7 +977,7 @@ get_atttypetypmodcoll(Oid relid, AttrNumber attnum,
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 attnum, relid);
-	att_tup = (Form_pg_attribute) GETSTRUCT(tp);
+	att_tup = GETSTRUCT(pg_attribute, tp);
 
 	*typid = att_tup->atttypid;
 	*typmod = att_tup->atttypmod;
@@ -1064,7 +1064,7 @@ get_collation_name(Oid colloid)
 	tp = SearchSysCache1(COLLOID, ObjectIdGetDatum(colloid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_collation colltup = (Form_pg_collation) GETSTRUCT(tp);
+		Form_pg_collation colltup = GETSTRUCT(pg_collation, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(colltup->collname));
@@ -1085,7 +1085,7 @@ get_collation_isdeterministic(Oid colloid)
 	tp = SearchSysCache1(COLLOID, ObjectIdGetDatum(colloid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for collation %u", colloid);
-	colltup = (Form_pg_collation) GETSTRUCT(tp);
+	colltup = GETSTRUCT(pg_collation, tp);
 	result = colltup->collisdeterministic;
 	ReleaseSysCache(tp);
 	return result;
@@ -1110,7 +1110,7 @@ get_constraint_name(Oid conoid)
 	tp = SearchSysCache1(CONSTROID, ObjectIdGetDatum(conoid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_constraint contup = (Form_pg_constraint) GETSTRUCT(tp);
+		Form_pg_constraint contup = GETSTRUCT(pg_constraint, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(contup->conname));
@@ -1142,7 +1142,7 @@ get_constraint_index(Oid conoid)
 	tp = SearchSysCache1(CONSTROID, ObjectIdGetDatum(conoid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_constraint contup = (Form_pg_constraint) GETSTRUCT(tp);
+		Form_pg_constraint contup = GETSTRUCT(pg_constraint, tp);
 		Oid			result;
 
 		if (contup->contype == CONSTRAINT_UNIQUE ||
@@ -1168,7 +1168,7 @@ get_language_name(Oid langoid, bool missing_ok)
 	tp = SearchSysCache1(LANGOID, ObjectIdGetDatum(langoid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_language lantup = (Form_pg_language) GETSTRUCT(tp);
+		Form_pg_language lantup = GETSTRUCT(pg_language, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(lantup->lanname));
@@ -1199,7 +1199,7 @@ get_opclass_family(Oid opclass)
 	tp = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclass));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for opclass %u", opclass);
-	cla_tup = (Form_pg_opclass) GETSTRUCT(tp);
+	cla_tup = GETSTRUCT(pg_opclass, tp);
 
 	result = cla_tup->opcfamily;
 	ReleaseSysCache(tp);
@@ -1221,7 +1221,7 @@ get_opclass_input_type(Oid opclass)
 	tp = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclass));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for opclass %u", opclass);
-	cla_tup = (Form_pg_opclass) GETSTRUCT(tp);
+	cla_tup = GETSTRUCT(pg_opclass, tp);
 
 	result = cla_tup->opcintype;
 	ReleaseSysCache(tp);
@@ -1244,7 +1244,7 @@ get_opclass_opfamily_and_input_type(Oid opclass, Oid *opfamily, Oid *opcintype)
 	if (!HeapTupleIsValid(tp))
 		return false;
 
-	cla_tup = (Form_pg_opclass) GETSTRUCT(tp);
+	cla_tup = GETSTRUCT(pg_opclass, tp);
 
 	*opfamily = cla_tup->opcfamily;
 	*opcintype = cla_tup->opcintype;
@@ -1270,7 +1270,7 @@ get_opcode(Oid opno)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+		Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 		RegProcedure result;
 
 		result = optup->oprcode;
@@ -1295,7 +1295,7 @@ get_opname(Oid opno)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+		Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(optup->oprname));
@@ -1318,7 +1318,7 @@ get_op_rettype(Oid opno)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+		Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 		Oid			result;
 
 		result = optup->oprresult;
@@ -1344,7 +1344,7 @@ op_input_types(Oid opno, Oid *lefttype, Oid *righttype)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (!HeapTupleIsValid(tp))	/* shouldn't happen */
 		elog(ERROR, "cache lookup failed for operator %u", opno);
-	optup = (Form_pg_operator) GETSTRUCT(tp);
+	optup = GETSTRUCT(pg_operator, tp);
 	*lefttype = optup->oprleft;
 	*righttype = optup->oprright;
 	ReleaseSysCache(tp);
@@ -1394,7 +1394,7 @@ op_mergejoinable(Oid opno, Oid inputtype)
 		tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 		if (HeapTupleIsValid(tp))
 		{
-			Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+			Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 
 			result = optup->oprcanmerge;
 			ReleaseSysCache(tp);
@@ -1440,7 +1440,7 @@ op_hashjoinable(Oid opno, Oid inputtype)
 		tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 		if (HeapTupleIsValid(tp))
 		{
-			Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+			Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 
 			result = optup->oprcanhash;
 			ReleaseSysCache(tp);
@@ -1494,7 +1494,7 @@ get_commutator(Oid opno)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+		Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 		Oid			result;
 
 		result = optup->oprcom;
@@ -1518,7 +1518,7 @@ get_negator(Oid opno)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+		Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 		Oid			result;
 
 		result = optup->oprnegate;
@@ -1542,7 +1542,7 @@ get_oprrest(Oid opno)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+		Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 		RegProcedure result;
 
 		result = optup->oprrest;
@@ -1566,7 +1566,7 @@ get_oprjoin(Oid opno)
 	tp = SearchSysCache1(OPEROID, ObjectIdGetDatum(opno));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_operator optup = (Form_pg_operator) GETSTRUCT(tp);
+		Form_pg_operator optup = GETSTRUCT(pg_operator, tp);
 		RegProcedure result;
 
 		result = optup->oprjoin;
@@ -1593,7 +1593,7 @@ get_func_name(Oid funcid)
 	tp = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_proc functup = (Form_pg_proc) GETSTRUCT(tp);
+		Form_pg_proc functup = GETSTRUCT(pg_proc, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(functup->proname));
@@ -1617,7 +1617,7 @@ get_func_namespace(Oid funcid)
 	tp = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_proc functup = (Form_pg_proc) GETSTRUCT(tp);
+		Form_pg_proc functup = GETSTRUCT(pg_proc, tp);
 		Oid			result;
 
 		result = functup->pronamespace;
@@ -1642,7 +1642,7 @@ get_func_rettype(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->prorettype;
+	result = (GETSTRUCT(pg_proc, tp))->prorettype;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1661,7 +1661,7 @@ get_func_nargs(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->pronargs;
+	result = (GETSTRUCT(pg_proc, tp))->pronargs;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1684,7 +1684,7 @@ get_func_signature(Oid funcid, Oid **argtypes, int *nargs)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	procstruct = (Form_pg_proc) GETSTRUCT(tp);
+	procstruct = GETSTRUCT(pg_proc, tp);
 
 	result = procstruct->prorettype;
 	*nargs = (int) procstruct->pronargs;
@@ -1710,7 +1710,7 @@ get_func_variadictype(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->provariadic;
+	result = (GETSTRUCT(pg_proc, tp))->provariadic;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1729,7 +1729,7 @@ get_func_retset(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->proretset;
+	result = (GETSTRUCT(pg_proc, tp))->proretset;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1748,7 +1748,7 @@ func_strict(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->proisstrict;
+	result = (GETSTRUCT(pg_proc, tp))->proisstrict;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1767,7 +1767,7 @@ func_volatile(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->provolatile;
+	result = (GETSTRUCT(pg_proc, tp))->provolatile;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1786,7 +1786,7 @@ func_parallel(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->proparallel;
+	result = (GETSTRUCT(pg_proc, tp))->proparallel;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1805,7 +1805,7 @@ get_func_prokind(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->prokind;
+	result = (GETSTRUCT(pg_proc, tp))->prokind;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1824,7 +1824,7 @@ get_func_leakproof(Oid funcid)
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
 
-	result = ((Form_pg_proc) GETSTRUCT(tp))->proleakproof;
+	result = (GETSTRUCT(pg_proc, tp))->proleakproof;
 	ReleaseSysCache(tp);
 	return result;
 }
@@ -1843,7 +1843,7 @@ get_func_support(Oid funcid)
 	tp = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_proc functup = (Form_pg_proc) GETSTRUCT(tp);
+		Form_pg_proc functup = GETSTRUCT(pg_proc, tp);
 		RegProcedure result;
 
 		result = functup->prosupport;
@@ -1884,7 +1884,7 @@ get_relnatts(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_class reltup = (Form_pg_class) GETSTRUCT(tp);
+		Form_pg_class reltup = GETSTRUCT(pg_class, tp);
 		int			result;
 
 		result = reltup->relnatts;
@@ -1913,7 +1913,7 @@ get_rel_name(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_class reltup = (Form_pg_class) GETSTRUCT(tp);
+		Form_pg_class reltup = GETSTRUCT(pg_class, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(reltup->relname));
@@ -1937,7 +1937,7 @@ get_rel_namespace(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_class reltup = (Form_pg_class) GETSTRUCT(tp);
+		Form_pg_class reltup = GETSTRUCT(pg_class, tp);
 		Oid			result;
 
 		result = reltup->relnamespace;
@@ -1964,7 +1964,7 @@ get_rel_type_id(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_class reltup = (Form_pg_class) GETSTRUCT(tp);
+		Form_pg_class reltup = GETSTRUCT(pg_class, tp);
 		Oid			result;
 
 		result = reltup->reltype;
@@ -1988,7 +1988,7 @@ get_rel_relkind(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_class reltup = (Form_pg_class) GETSTRUCT(tp);
+		Form_pg_class reltup = GETSTRUCT(pg_class, tp);
 		char		result;
 
 		result = reltup->relkind;
@@ -2012,7 +2012,7 @@ get_rel_relispartition(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_class reltup = (Form_pg_class) GETSTRUCT(tp);
+		Form_pg_class reltup = GETSTRUCT(pg_class, tp);
 		bool		result;
 
 		result = reltup->relispartition;
@@ -2039,7 +2039,7 @@ get_rel_tablespace(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_class reltup = (Form_pg_class) GETSTRUCT(tp);
+		Form_pg_class reltup = GETSTRUCT(pg_class, tp);
 		Oid			result;
 
 		result = reltup->reltablespace;
@@ -2065,7 +2065,7 @@ get_rel_persistence(Oid relid)
 	tp = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	reltup = (Form_pg_class) GETSTRUCT(tp);
+	reltup = GETSTRUCT(pg_class, tp);
 	result = reltup->relpersistence;
 	ReleaseSysCache(tp);
 
@@ -2088,7 +2088,7 @@ get_transform_fromsql(Oid typid, Oid langid, List *trftypes)
 	{
 		Oid			funcid;
 
-		funcid = ((Form_pg_transform) GETSTRUCT(tup))->trffromsql;
+		funcid = (GETSTRUCT(pg_transform, tup))->trffromsql;
 		ReleaseSysCache(tup);
 		return funcid;
 	}
@@ -2109,7 +2109,7 @@ get_transform_tosql(Oid typid, Oid langid, List *trftypes)
 	{
 		Oid			funcid;
 
-		funcid = ((Form_pg_transform) GETSTRUCT(tup))->trftosql;
+		funcid = (GETSTRUCT(pg_transform, tup))->trftosql;
 		ReleaseSysCache(tup);
 		return funcid;
 	}
@@ -2134,7 +2134,7 @@ get_typisdefined(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		bool		result;
 
 		result = typtup->typisdefined;
@@ -2158,7 +2158,7 @@ get_typlen(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		int16		result;
 
 		result = typtup->typlen;
@@ -2183,7 +2183,7 @@ get_typbyval(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		bool		result;
 
 		result = typtup->typbyval;
@@ -2213,7 +2213,7 @@ get_typlenbyval(Oid typid, int16 *typlen, bool *typbyval)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	typtup = (Form_pg_type) GETSTRUCT(tp);
+	typtup = GETSTRUCT(pg_type, tp);
 	*typlen = typtup->typlen;
 	*typbyval = typtup->typbyval;
 	ReleaseSysCache(tp);
@@ -2234,7 +2234,7 @@ get_typlenbyvalalign(Oid typid, int16 *typlen, bool *typbyval,
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	typtup = (Form_pg_type) GETSTRUCT(tp);
+	typtup = GETSTRUCT(pg_type, tp);
 	*typlen = typtup->typlen;
 	*typbyval = typtup->typbyval;
 	*typalign = typtup->typalign;
@@ -2259,7 +2259,7 @@ get_typlenbyvalalign(Oid typid, int16 *typlen, bool *typbyval,
 Oid
 getTypeIOParam(HeapTuple typeTuple)
 {
-	Form_pg_type typeStruct = (Form_pg_type) GETSTRUCT(typeTuple);
+	Form_pg_type typeStruct = GETSTRUCT(pg_type, typeTuple);
 
 	/*
 	 * Array types get their typelem as parameter; everybody else gets their
@@ -2326,7 +2326,7 @@ get_type_io_data(Oid typid,
 	typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(typeTuple))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	typeStruct = (Form_pg_type) GETSTRUCT(typeTuple);
+	typeStruct = GETSTRUCT(pg_type, typeTuple);
 
 	*typlen = typeStruct->typlen;
 	*typbyval = typeStruct->typbyval;
@@ -2360,7 +2360,7 @@ get_typalign(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		char		result;
 
 		result = typtup->typalign;
@@ -2380,7 +2380,7 @@ get_typstorage(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		char		result;
 
 		result = typtup->typstorage;
@@ -2413,7 +2413,7 @@ get_typdefault(Oid typid)
 	typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(typeTuple))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	type = (Form_pg_type) GETSTRUCT(typeTuple);
+	type = GETSTRUCT(pg_type, typeTuple);
 
 	/*
 	 * typdefault and typdefaultbin are potentially null, so don't try to
@@ -2505,7 +2505,7 @@ getBaseTypeAndTypmod(Oid typid, int32 *typmod)
 		tup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for type %u", typid);
-		typTup = (Form_pg_type) GETSTRUCT(tup);
+		typTup = GETSTRUCT(pg_type, tup);
 		if (typTup->typtype != TYPTYPE_DOMAIN)
 		{
 			/* Not a domain, so done */
@@ -2590,7 +2590,7 @@ get_typtype(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		char		result;
 
 		result = typtup->typtype;
@@ -2672,7 +2672,7 @@ get_type_category_preferred(Oid typid, char *typcategory, bool *typispreferred)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	typtup = (Form_pg_type) GETSTRUCT(tp);
+	typtup = GETSTRUCT(pg_type, tp);
 	*typcategory = typtup->typcategory;
 	*typispreferred = typtup->typispreferred;
 	ReleaseSysCache(tp);
@@ -2692,7 +2692,7 @@ get_typ_typrelid(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		Oid			result;
 
 		result = typtup->typrelid;
@@ -2720,7 +2720,7 @@ get_element_type(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		Oid			result;
 
 		if (IsTrueArrayType(typtup))
@@ -2749,7 +2749,7 @@ get_array_type(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		result = ((Form_pg_type) GETSTRUCT(tp))->typarray;
+		result = (GETSTRUCT(pg_type, tp))->typarray;
 		ReleaseSysCache(tp);
 	}
 	return result;
@@ -2799,7 +2799,7 @@ get_base_element_type(Oid typid)
 		tup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 		if (!HeapTupleIsValid(tup))
 			break;
-		typTup = (Form_pg_type) GETSTRUCT(tup);
+		typTup = GETSTRUCT(pg_type, tup);
 		if (typTup->typtype != TYPTYPE_DOMAIN)
 		{
 			/* Not a domain, so stop descending */
@@ -2836,7 +2836,7 @@ getTypeInputInfo(Oid type, Oid *typInput, Oid *typIOParam)
 	typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(type));
 	if (!HeapTupleIsValid(typeTuple))
 		elog(ERROR, "cache lookup failed for type %u", type);
-	pt = (Form_pg_type) GETSTRUCT(typeTuple);
+	pt = GETSTRUCT(pg_type, typeTuple);
 
 	if (!pt->typisdefined)
 		ereport(ERROR,
@@ -2869,7 +2869,7 @@ getTypeOutputInfo(Oid type, Oid *typOutput, bool *typIsVarlena)
 	typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(type));
 	if (!HeapTupleIsValid(typeTuple))
 		elog(ERROR, "cache lookup failed for type %u", type);
-	pt = (Form_pg_type) GETSTRUCT(typeTuple);
+	pt = GETSTRUCT(pg_type, typeTuple);
 
 	if (!pt->typisdefined)
 		ereport(ERROR,
@@ -2902,7 +2902,7 @@ getTypeBinaryInputInfo(Oid type, Oid *typReceive, Oid *typIOParam)
 	typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(type));
 	if (!HeapTupleIsValid(typeTuple))
 		elog(ERROR, "cache lookup failed for type %u", type);
-	pt = (Form_pg_type) GETSTRUCT(typeTuple);
+	pt = GETSTRUCT(pg_type, typeTuple);
 
 	if (!pt->typisdefined)
 		ereport(ERROR,
@@ -2935,7 +2935,7 @@ getTypeBinaryOutputInfo(Oid type, Oid *typSend, bool *typIsVarlena)
 	typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(type));
 	if (!HeapTupleIsValid(typeTuple))
 		elog(ERROR, "cache lookup failed for type %u", type);
-	pt = (Form_pg_type) GETSTRUCT(typeTuple);
+	pt = GETSTRUCT(pg_type, typeTuple);
 
 	if (!pt->typisdefined)
 		ereport(ERROR,
@@ -2967,7 +2967,7 @@ get_typmodin(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		Oid			result;
 
 		result = typtup->typmodin;
@@ -2992,7 +2992,7 @@ get_typmodout(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		Oid			result;
 
 		result = typtup->typmodout;
@@ -3017,7 +3017,7 @@ get_typcollation(Oid typid)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typtup = GETSTRUCT(pg_type, tp);
 		Oid			result;
 
 		result = typtup->typcollation;
@@ -3058,7 +3058,7 @@ get_typsubscript(Oid typid, Oid *typelemp)
 	tp = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_type typform = (Form_pg_type) GETSTRUCT(tp);
+		Form_pg_type typform = GETSTRUCT(pg_type, tp);
 		RegProcedure handler = typform->typsubscript;
 
 		if (typelemp)
@@ -3129,7 +3129,7 @@ get_attavgwidth(Oid relid, AttrNumber attnum)
 						 BoolGetDatum(false));
 	if (HeapTupleIsValid(tp))
 	{
-		stawidth = ((Form_pg_statistic) GETSTRUCT(tp))->stawidth;
+		stawidth = (GETSTRUCT(pg_statistic, tp))->stawidth;
 		ReleaseSysCache(tp);
 		if (stawidth > 0)
 			return stawidth;
@@ -3187,7 +3187,7 @@ bool
 get_attstatsslot(AttStatsSlot *sslot, HeapTuple statstuple,
 				 int reqkind, Oid reqop, int flags)
 {
-	Form_pg_statistic stats = (Form_pg_statistic) GETSTRUCT(statstuple);
+	Form_pg_statistic stats = GETSTRUCT(pg_statistic, statstuple);
 	int			i;
 	Datum		val;
 	bool		isnull;
@@ -3236,7 +3236,7 @@ get_attstatsslot(AttStatsSlot *sslot, HeapTuple statstuple,
 		typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(arrayelemtype));
 		if (!HeapTupleIsValid(typeTuple))
 			elog(ERROR, "cache lookup failed for type %u", arrayelemtype);
-		typeForm = (Form_pg_type) GETSTRUCT(typeTuple);
+		typeForm = GETSTRUCT(pg_type, typeTuple);
 
 		/* Deconstruct array into Datum elements; NULLs not expected */
 		deconstruct_array(statarray,
@@ -3330,7 +3330,7 @@ get_namespace_name(Oid nspid)
 	tp = SearchSysCache1(NAMESPACEOID, ObjectIdGetDatum(nspid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_namespace nsptup = (Form_pg_namespace) GETSTRUCT(tp);
+		Form_pg_namespace nsptup = GETSTRUCT(pg_namespace, tp);
 		char	   *result;
 
 		result = pstrdup(NameStr(nsptup->nspname));
@@ -3371,7 +3371,7 @@ get_range_subtype(Oid rangeOid)
 	tp = SearchSysCache1(RANGETYPE, ObjectIdGetDatum(rangeOid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_range rngtup = (Form_pg_range) GETSTRUCT(tp);
+		Form_pg_range rngtup = GETSTRUCT(pg_range, tp);
 		Oid			result;
 
 		result = rngtup->rngsubtype;
@@ -3397,7 +3397,7 @@ get_range_collation(Oid rangeOid)
 	tp = SearchSysCache1(RANGETYPE, ObjectIdGetDatum(rangeOid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_range rngtup = (Form_pg_range) GETSTRUCT(tp);
+		Form_pg_range rngtup = GETSTRUCT(pg_range, tp);
 		Oid			result;
 
 		result = rngtup->rngcollation;
@@ -3422,7 +3422,7 @@ get_range_multirange(Oid rangeOid)
 	tp = SearchSysCache1(RANGETYPE, ObjectIdGetDatum(rangeOid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_range rngtup = (Form_pg_range) GETSTRUCT(tp);
+		Form_pg_range rngtup = GETSTRUCT(pg_range, tp);
 		Oid			result;
 
 		result = rngtup->rngmultitypid;
@@ -3447,7 +3447,7 @@ get_multirange_range(Oid multirangeOid)
 	tp = SearchSysCache1(RANGEMULTIRANGE, ObjectIdGetDatum(multirangeOid));
 	if (HeapTupleIsValid(tp))
 	{
-		Form_pg_range rngtup = (Form_pg_range) GETSTRUCT(tp);
+		Form_pg_range rngtup = GETSTRUCT(pg_range, tp);
 		Oid			result;
 
 		result = rngtup->rngtypid;
@@ -3484,7 +3484,7 @@ get_index_column_opclass(Oid index_oid, int attno)
 	if (!HeapTupleIsValid(tuple))
 		return InvalidOid;
 
-	rd_index = (Form_pg_index) GETSTRUCT(tuple);
+	rd_index = GETSTRUCT(pg_index, tuple);
 
 	/* caller is supposed to guarantee this */
 	Assert(attno > 0 && attno <= rd_index->indnatts);
@@ -3526,7 +3526,7 @@ get_index_isreplident(Oid index_oid)
 	if (!HeapTupleIsValid(tuple))
 		return false;
 
-	rd_index = (Form_pg_index) GETSTRUCT(tuple);
+	rd_index = GETSTRUCT(pg_index, tuple);
 	result = rd_index->indisreplident;
 	ReleaseSysCache(tuple);
 
@@ -3549,7 +3549,7 @@ get_index_isvalid(Oid index_oid)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for index %u", index_oid);
 
-	rd_index = (Form_pg_index) GETSTRUCT(tuple);
+	rd_index = GETSTRUCT(pg_index, tuple);
 	isvalid = rd_index->indisvalid;
 	ReleaseSysCache(tuple);
 
